Bug 1748471 - Review Request: xtensor-python - Python bindings for xtensor
Summary: Review Request: xtensor-python - Python bindings for xtensor
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Miro Hrončok
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1748470
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-09-03 16:29 UTC by serge_sans_paille
Modified: 2019-09-17 11:14 UTC (History)
3 users (show)

Fixed In Version: xtensor-python-0.23.1-0.fc32
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-09-17 11:14:55 UTC
mhroncok: fedora-review+


Attachments (Terms of Use)

Description serge_sans_paille 2019-09-03 16:29:45 UTC
Spec URL: https://sergesanspaille.fedorapeople.org/xtensor-python.spec
SRPM URL: https://sergesanspaille.fedorapeople.org/xtensor-python-0.23.1-0.fc31.src.rpm
Description: xtensor-python enables inplace use of numpy arrays in C++ with all the benefits from xtensor: C++ universal function and broadcasting, STL-compliant APIs, A broad coverage of Numpy APIs.
Fedora Account System Username: sergesanspaille

Comment 1 Elliott Sales de Andrade 2019-09-05 04:29:50 UTC
Python packages MUST be named python-*, and since this one ends in -python too, you probably will want to name it python-xtensor.

URL should be https://

In the description, STL-compliant should not have spaces, and it should be capitalized as NumPy.

Comment 2 Miro Hrončok 2019-09-05 08:12:26 UTC
Note that this is not a Python package.

Comment 3 serge_sans_paille 2019-09-05 11:53:21 UTC
@Elliott: spec file description + URL updated as suggested

And I second Miro, this is not a Python package, it's a header-only C++ package.

New SRPM URL: SRPM URL: https://sergesanspaille.fedorapeople.org/xtensor-python-0.23.1-0.fc32.src.rpm

Comment 4 Miro Hrončok 2019-09-10 09:23:38 UTC
I cannot build the package:

  Processing files: xtensor-python-debugsource-0.23.1-0.fc32.x86_64
  RPM build errors:
  error: Empty %files file /builddir/build/BUILD/xtensor-python-0.23.1/debugsourcefiles.list


I think it requires:

  # there is no actual arched content - this is a header only library
  %global debug_package %{nil}

Comment 6 Miro Hrončok 2019-09-12 13:37:53 UTC
This is a header only library.

See https://docs.fedoraproject.org/en-US/packaging-guidelines/#_packaging_header_only_libraries


%package devel
Summary:        %{summary}
Provides:       %{name} = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}
Requires:       pybind11-devel
Requires:       python3-devel
Requires:       xtensor-devel
Requires:       python3-numpy

%description devel %_description

Comment 7 Miro Hrončok 2019-09-12 13:41:07 UTC
Changelog doesn't match release (and a release is zero).

---

A note: xtensor-python-0.23.1/cmake/FindNumPy.cmake is MIT but is not shipped in the built RPM (OK).

Comment 8 serge_sans_paille 2019-09-12 18:31:21 UTC
Thanks again for the review, I indeed forgot a large part of the spec file, everything got re-uploaded again.

Comment 9 Miro Hrončok 2019-09-12 18:53:10 UTC
Package Review
==============

           _____  _____  _______      ______  ______ _____  
     /\   |  __ \|  __ \|  __ \ \    / / __ \|  ____|  __ \ 
    /  \  | |__) | |__) | |__) \ \  / / |  | | |__  | |  | |
   / /\ \ |  ___/|  ___/|  _  / \ \/ /| |  | |  __| | |  | |
  / ____ \| |    | |    | | \ \  \  / | |__| | |____| |__| |
 /_/    \_\_|    |_|    |_|  \_\  \/   \____/|______|_____/ 
                                                            


Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: BSD file in source RPM, not shipped in built one.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: xtensor-python-devel-0.23.1-0.fc32.x86_64.rpm
          xtensor-python-0.23.1-0.fc32.src.rpm
xtensor-python-devel.x86_64: W: only-non-binary-in-usr-lib
2 packages and 0 specfiles checked; 0 errors, 1 warnings.

good.


Rpmlint (installed packages)
----------------------------
xtensor-python-devel.x86_64: W: invalid-url URL: https://xtensor-python.readthedocs.io/ <urlopen error [Errno -2] Name or service not known>
xtensor-python-devel.x86_64: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

good.

Source checksums
----------------
https://github.com/QuantStack/xtensor-python/archive/0.23.1/xtensor-python-0.23.1.tar.gz :
  CHECKSUM(SHA256) this package     : 450b25f5c739df174b2a50774b89e68b23535fdc37cb55bd542ffdb7c78991ab
  CHECKSUM(SHA256) upstream package : 450b25f5c739df174b2a50774b89e68b23535fdc37cb55bd542ffdb7c78991ab


Requires
--------
xtensor-python-devel (rpmlib, GLIBC filtered):
    cmake-filesystem(x86-64)
    pybind11-devel
    python3-devel
    python3-numpy
    xtensor-devel



Provides
--------
xtensor-python-devel:
    cmake(xtensor-python)
    xtensor-python
    xtensor-python-devel
    xtensor-python-devel(x86-64)
    xtensor-python-static

Comment 10 Miro Hrončok 2019-09-12 18:53:44 UTC
The facepalm when I put a typo into ASCII art :D

Comment 11 serge_sans_paille 2019-09-14 12:02:50 UTC
:-)

Comment 12 Gwyn Ciesla 2019-09-16 13:49:25 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/xtensor-python


Note You need to log in before you can comment on or make changes to this bug.